import { Count, Filter, FilterExcludingWhere, Where } from '@loopback/repository';
import { Strategy } from '../models';
import { StrategyRepository } from '../repositories';
export declare class StrategyController {
    strategyRepository: StrategyRepository;
    constructor(strategyRepository: StrategyRepository);
    create(strategy: Strategy): Promise<Strategy>;
    count(where?: Where<Strategy>): Promise<Count>;
    find(filter?: Filter<Strategy>): Promise<Strategy[]>;
    updateAll(strategy: Strategy, where?: Where<Strategy>): Promise<Count>;
    findById(id: string, filter?: FilterExcludingWhere<Strategy>): Promise<Strategy>;
    updateById(id: string, strategy: Strategy): Promise<void>;
    replaceById(id: string, strategy: Strategy): Promise<void>;
    deleteById(id: string): Promise<void>;
}
